function [x0,err] = bisect_opt1(xn,xp);
maxit = 100;
tol = 1.0e-6;
err = 100.0;
icount = 0;
h = min(0.01*xn,0.01);
fn = dfunkeval(xn,h);
h = min(0.01*xp,0.01);
fp = dfunkeval(xp,h);
while (err > tol & icount <= maxit)
   icount = icount + 1;
   xmid = (xn + xp)/2;
   h = min(0.01*xp,0.01);
   fmid = dfunkeval(xmid,h);
   if (fmid > 0)
      fp = fmid;
      xp = xmid;
   else
      fn = fmid;
      xn = xmid;
   end
   err = abs((xp - xn)/xp);
   fprintf(1,'i = %i xn = %e xp = %e fn = %e fp = %e err = %e \n',icount, xn, xp, fn, fp, err);
end
x0 = xmid;
if (icount >= maxit)
   fprintf(1,'Sorry.  You did not converge in %i iterations.\n',maxit);
   fprintf(1,'The final value of x was %e \n', x0);
end

function df = dfunkeval(x,h)
fp = funkeval(x+h);
fn = funkeval(x-h);
df = (fp - fn)/(2*h);

function f = funkeval(x)
f = exp(x)-sqrt(x);


