function [x,err,f] = nrnd_optn(x0,tol,iprint)
maxit = 1000;
n = max(size(x0));
Residual = zeros(n,1); 
Jacobian = zeros(n,n);
InvJ = zeros(n,n);
dx = zeros(n,1);
x = zeros(n,1);
xold = zeros(n,1);
dxcon = zeros(n,1);
dxcon(1:n) = 0.01;
x = x0;
err = 100.0;
iter = 0;
while ( err > tol ) 
   for j = 1:1:n
   	dx(j) = min(dxcon(j)*x(j),dxcon(j));
   end
   Residual = dfunkeval(x,dx,n);
   Jacobian = d2funkeval(x,dx,n);
   xold = x;
   invJ = inv(Jacobian);
   deltax = -invJ*Residual;
   for j = 1:1:n
      x(j) = xold(j) + deltax(j);
   end
   iter = iter +1;
   err = sqrt( sum(deltax.^2) /n  ) ;
   f = sqrt(sum(Residual.*Residual)/n);
   x
   if (iprint == 1)
      fprintf (1,'iter = %4i, err = %9.2e f = %9.2e \n ', iter, err, f);
   end
   if ( iter > maxit)
      Residual
      error ('maximum number of iterations exceeded');
   end
end

function df = dfunkeval(x,dx,n)
df = zeros(n,1);
for i = 1:1:n 
   xtemp(1:n) = x(1:n);
   xtemp(i) = x(i) + dx(i);
   fp = funkeval(xtemp);
   xtemp(i) = x(i) - dx(i);
   fn = funkeval(xtemp);
   df(i) = (fp - fn)/(2*dx(i));
end

function Jacobian = d2funkeval(x,dx,n)
Jacobian = zeros(n,n);
for i = 1:1:n
   xtemp(1:n) = x(1:n);
   xtemp(i) = x(i) + dx(i);
   fp = funkeval(xtemp);
   xtemp(i) = x(i);
   fo = funkeval(xtemp);
   xtemp(i) = x(i) - dx(i);
   fn = funkeval(xtemp);
   Jacobian(i,i) = (fp - 2*fo + fn)/(dx(i)*dx(i));
end
for i = 1:1:n-1
   for j = i+1:1:n
      xtemp(1:n) = x(1:n);
      xtemp(i) = x(i) + dx(i);
      xtemp(j) = x(j) + dx(i);
      fpp = funkeval(xtemp);
      xtemp(i) = x(i) + dx(i);
      xtemp(j) = x(j) - dx(i);
      fpn = funkeval(xtemp);
      xtemp(i) = x(i) - dx(i);
      xtemp(j) = x(j) + dx(i);
      fnp = funkeval(xtemp);
      xtemp(i) = x(i) - dx(i);
      xtemp(j) = x(j) - dx(i);
      fnn = funkeval(xtemp);
      Jacobian(i,j) = (fpp - fpn -fnp + fnn)/(4*dx(i)*dx(j));
   end   
end
for i = 2:1:n
   for j = 1:1:i-1
      Jacobian(i,j) = Jacobian(j,i);
   end
end

function fobj = funkeval(x)
fobj = (x(1)-3)^2 + (x(2)-7)^2 + x(1)*x(2)^2 - x(1)^2*x(2) + 4;
