function [b,bsd,bcilo,bcihi,MOF] = linreg1ci(x,y,CI);
n = max(size(x));
b = zeros(2,1);
bsd = zeros(2,1);
bcilo = zeros(2,1);
bcihi = zeros(2,1);
yhat = zeros(n,1);
xsum = sum(x);
xavg = xsum/n;
ysum = sum(y);
yavg = ysum/n;
x2sum = sum(x.*x);
x2avg = x2sum/n;
xvarsum = sum((x-xavg).*(x-xavg));
yvarsum = sum((y-yavg).*(y-yavg));
xycovarsum = sum((x-xavg).*(y-yavg));
b(2) = xycovarsum/xvarsum;
b(1) = yavg - b(2)*xavg;
yhat = b(1) + b(2)*x;
SSR = sum((yhat - yavg).^2);
SSE = sum((y - yhat).^2);
SST = SSR + SSE;
MOF = SSR/SST;
sigma = SSE/(n-2);
bsd(2) = sigma/xvarsum;
bsd(1) = x2avg*sigma/xvarsum;
bsd(1:2) = sqrt(bsd(1:2));
v = n-2;
alpha = (1 - CI/100)/2;
%  need critical value of t statistic here!
cipalpha = CI/100.0 + alpha;
talpha = icdf('t',cipalpha,v);
bcilo(1) = b(1) - talpha*bsd(1);
bcihi(1) = b(1) + talpha*bsd(1);
bcilo(2) = b(2) - talpha*bsd(2);
bcihi(2) = b(2) + talpha*bsd(2);
xmin = min(x);
xmax = max(x);
nx = 20;
dx = (xmax - xmin)/nx;
xci = zeros(nx,1);
ycilo = zeros(nx,1);
ycihi = zeros(nx,1);
for i = 1:1:nx+1
  xci(i) = xmin + (i-1)*dx;
end
for i = 1:1:nx+1
   thing = 1/n + (xci(i) - xavg)^2/(x2sum - xsum*xsum/n);
   sig = sqrt(thing*sigma);
   ycilo(i) = b(1) + b(2)*xci(i) - talpha*sig;
   ycihi(i) = b(1) + b(2)*xci(i) + talpha*sig;     
end
figure(1);
plot(x,y,'ro'), xlabel( 'x' ), ylabel ( 'y' );         
hold on;
plot(x,yhat,'k-');
hold on;
plot(xci,ycilo,'g--');
hold on;
plot(xci,ycihi,'g--');
hold off;

